import java.awt.*;
import java.io.*;
import java.security.*;
import au.net.aba.crypto.provider.ABAProvider;
import au.net.aba.crypto.*;
import java.security.spec.*;
import java.security.cert.*;
import sun.security.x509.*;
import javax.crypto.*;
import javacard.*;

public class ReqDialog extends Dialog {

	public ReqDialog(SmartWallet parent, boolean modal)
	{
		super(parent, modal);
		this.parent = parent;
		
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(395,384);
		setVisible(false);
		label2.setText("Common Name");
		add(label2);
		label2.setBounds(24,60,156,24);
		txtMsg.setText("Select your choice ...");
		add(txtMsg);
		txtMsg.setForeground(java.awt.Color.gray);
		txtMsg.setBounds(24,300,336,24);
		label7.setText("Certificate Distinguished Name");
		label7.setAlignment(java.awt.Label.CENTER);
		add(label7);
		label7.setBackground(new java.awt.Color(194,187,198));
		label7.setFont(new Font("Dialog", Font.PLAIN, 14));
		label7.setBounds(12,12,372,32);
		label1.setText("Organization Unit");
		add(label1);
		label1.setBounds(24,84,156,24);
		label3.setText("Organization Name");
		add(label3);
		label3.setBounds(24,108,156,24);
		label4.setText("Locality / City Name");
		add(label4);
		label4.setBounds(24,132,156,24);
		label5.setText("State Name");
		add(label5);
		label5.setBounds(24,156,156,24);
		label6.setText("Country");
		add(label6);
		label6.setBounds(24,180,156,24);
		label8.setText("Certificate Authority");
		add(label8);
		label8.setBounds(24,228,156,24);
		label9.setText("CA - IP Address (Request)");
		add(label9);
		label9.setBounds(24,264,156,24);
		add(txtCN);
		txtCN.setBounds(204,60,160,24);
		txtCN.setEditable(false);
		add(txtOU);
		txtOU.setBounds(204,84,160,24);
		txtOU.setEditable(false);
		add(txtON);
		txtON.setBounds(204,108,160,24);
		txtON.setEditable(false);
		add(txtLN);
		txtLN.setBounds(204,132,160,24);
		txtLN.setEditable(false);
		add(txtSN);
		txtSN.setBounds(204,156,160,24);
		txtSN.setEditable(false);
		add(txtCO);
		txtCO.setBounds(204,180,160,24);
		txtCO.setEditable(false);
		add(txtCA);
		txtCA.setBounds(204,228,160,24);
		txtCA.setEditable(false);
		add(txtIP);
		txtIP.setBounds(204,264,160,24);
		btnSave.setLabel("Save File");
		add(btnSave);
		btnSave.setBounds(120,336,79,26);
		btnRequest.setLabel("Request");
		add(btnRequest);
		btnRequest.setBounds(216,336,72,27);
		btnFinish.setLabel("Finish");
		add(btnFinish);
		btnFinish.setBounds(300,336,66,27);
		setTitle("SmartWallet - View Certificate");
		setResizable(false);
		//}}
        
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		btnFinish.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		btnSave.addActionListener(lSymAction);
		btnRequest.addActionListener(lSymAction);
		//}}
		loadCert(); // buka sertifikat
	}
    
	public ReqDialog(SmartWallet parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
                Dimension d = getSize();

		super.addNotify();

		// Only do this once.
		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}

		// Used for addNotify check.
		fComponentsAdjusted = true;
	}

	public void setVisible(boolean b)
	{
	    if (b)
	    {
    		Rectangle bounds = getParent().getBounds();
    		Rectangle abounds = getBounds();

    		setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    			 bounds.y + (bounds.height - abounds.height)/2);
	    }

		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label txtMsg = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.TextField txtCN = new java.awt.TextField();
	java.awt.TextField txtOU = new java.awt.TextField();
	java.awt.TextField txtON = new java.awt.TextField();
	java.awt.TextField txtLN = new java.awt.TextField();
	java.awt.TextField txtSN = new java.awt.TextField();
	java.awt.TextField txtCO = new java.awt.TextField();
	java.awt.TextField txtCA = new java.awt.TextField();
	java.awt.TextField txtIP = new java.awt.TextField();
	java.awt.Button btnSave = new java.awt.Button();
	java.awt.Button btnRequest = new java.awt.Button();
	java.awt.Button btnFinish = new java.awt.Button();
	//}}
    
  // Used for addNotify check.
	boolean fComponentsAdjusted = false;
	// sertifikat
	X509Certificate x509certificate;
	// for my parent
	SmartWallet parent;

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == btnFinish)
				btnFinish_ActionPerformed(event);
			else if (object == btnSave)
				btnSave_ActionPerformed(event);
			else if (object == btnRequest)
				btnRequest_ActionPerformed(event);
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == ReqDialog.this)
				ReqDialog_WindowClosing(event);
		}
	}

	void ReqDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		ReqDialog_WindowClosing_Interaction1(event);
	}


	void ReqDialog_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}


	void btnFinish_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
		}
	}

	void btnSave_ActionPerformed(java.awt.event.ActionEvent event) {
		try {
			// simpan sertifikat
			dumpCert((txtCN.getText()).trim() + ".cer");

			txtMsg.setText("Certificate saved !");
		} catch(Exception e) { System.err.println(e); }
	}

	void btnRequest_ActionPerformed(java.awt.event.ActionEvent event) {
		if ((txtIP.getText()).equals("")) {
			txtMsg.setText("IP Address can't be empty !");
			return;	
		}

		x509certificate = CertReq.createRequest(x509certificate);
		
		txtMsg.setText("Certificate has been signed by CA !");
	}

	void loadCert() {
		if (parent.isOpen == false) {
			btnSave.setVisible(false);
			btnRequest.setVisible(false);
			txtMsg.setText("Open your identification first !");
			return;
		}

		x509certificate = (X509Certificate)parent.certificate;
    X500Name x500name = (X500Name)x509certificate.getSubjectDN();
    X500Name x500name1 = (X500Name)x509certificate.getIssuerDN();

		try {
			txtCN.setText(x500name.getCommonName());
			txtOU.setText(x500name.getOrganizationalUnit());
			txtON.setText(x500name.getOrganization());
			txtLN.setText(x500name.getLocality());
			txtSN.setText(x500name.getState());
			txtCO.setText(x500name.getCountry());
			txtCA.setText(x500name1.getCommonName());
		} catch (IOException e) {System.err.println(e);}
	}

	private void dumpCert(String filename)
  	throws IOException, CertificateException
  {
    PrintStream printstream = new PrintStream(new FileOutputStream(filename));
		printstream.write(((java.security.cert.Certificate)x509certificate).getEncoded());
  }

}